package org.ii;

import javax.naming.NamingException;

import org.ii.jaas.exceptions.AccountNotFoundException;
import org.ii.jaas.exceptions.RoleNotFoundException;
import org.ii.jaas.exceptions.RoleTitleNotUniqueException;
import org.ii.jaas.exceptions.AccountUsernameNotUniqueException;
import org.jboss.system.ServiceMBean;

/**
 * @author amissine
 */
public interface UserAccountsServiceMBean extends ServiceMBean 
{
	void addRole( String title ) throws RoleTitleNotUniqueException;
	void deleteRole( String title ) throws RoleNotFoundException;
	void addAccount( String username, String password ) throws AccountUsernameNotUniqueException;
	void changePassword( String username, String password, String newPassword ) throws AccountNotFoundException;
	boolean isDisabled( String username ) throws AccountNotFoundException;
	void enable( String username, boolean enable ) throws AccountNotFoundException;
	void deleteAccount( String username ) throws AccountNotFoundException;
	void addRoleToAccount( String title, String username ) throws RoleNotFoundException, AccountNotFoundException;
	void deleteRoleFromAccount( String title, String username ) throws RoleNotFoundException, AccountNotFoundException;
    String getJndiName();
    void setJndiName(String jndiName) throws NamingException;
	String listAll();
}
