/*
 * Created on Jun 21, 2005
 */
package org.ii.valve;

import java.io.IOException;

import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.catalina.connector.Request;
import org.apache.catalina.connector.Response;
import org.apache.catalina.valves.ValveBase;
import org.apache.log4j.Logger;
import org.ii.UserAccountsServiceMBean;

/**
 * @author amissine
 */
public class FormLoginValve extends ValveBase 
{
	static Logger log = Logger.getLogger(FormLoginValve.class);
	static String jndiName;

	/**
	 * @see org.apache.catalina.Valve#invoke(org.apache.catalina.connector.Request, org.apache.catalina.connector.Response)
	 */
	public void invoke(Request request, Response response) 
		throws IOException, ServletException 
	{
		HttpServletRequest hsr = (HttpServletRequest)request;
		String username = hsr.getParameter("j_username");
		String password = hsr.getParameter("j_password");
		String newPassword = hsr.getParameter("new_password");
		
		getNext().invoke(request, response);
		
		if( username != null && password != null )	// intercepting j_security_check
		{
			HttpSession hs = hsr.getSession(false);
			Boolean authenticated = (Boolean)hs.getAttribute("authenticated");	// null means authenticated, false means NOT
			hs.removeAttribute("authenticated");
			if( authenticated != null && !authenticated.booleanValue() )	// user NOT authenticated
			{
				hs.setAttribute("username", username);
				return;
			}
			if( newPassword == null || newPassword.length() == 0 ) return;	// password change not requested

			if( jndiName == null ) jndiName = hs.getServletContext().getInitParameter("UserAccounts-JNDI-name");
			try 
			{
				InitialContext ctx = new InitialContext();
				UserAccountsServiceMBean uas = (UserAccountsServiceMBean) ctx.lookup(jndiName);
				uas.changePassword(username, password, newPassword);
			} 
			catch( Exception e ) 
			{
				log.error("Unexpected", e);
			}		
		}
	}
}
